﻿using System;
using System.Data;

namespace SchemaExplorer.CustomSchemaProvider
{
    public class CustomSchemaProvider : SchemaExplorer.IDbSchemaProvider, SchemaExplorer.IDbConnectionStringEditor
    {
        #region Implementation of IDbSchemaProvider

        /// <summary>
        /// Gets the name of the schema provider (E.G. SqlSchemaProvider).
        /// </summary>
        public string Name
        {
            get { return "CustomSchemaProvider"; }
        }

        /// <summary>
        /// Gets the description for the schema provider (E.G. SQL Server Schema Provider)..
        /// </summary>
        public string Description { get { return "A Custom Schema Provider"; } }

        /// <summary>
        /// Gets the name of the database.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <returns>The name of the database</returns>
        public string GetDatabaseName(string connectionString)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the extended property collection for a given schema object.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="schemaObject">Any type that derives from SchemaObjectBase. (E.G. DatabaseSchema, TableSchema, ColumnSchema, ViewSchema, ViewColumnSchema, IndexSchema, CommandSchema, ParameterSchema, PrimaryKeySchema, TableKeySchema)</param>
        /// <returns>An array of ExtendedProperties for a specific SchemaObjectBase.</returns>
        public ExtendedProperty[] GetExtendedProperties(string connectionString, SchemaObjectBase schemaObject)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Sets the extended properties.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="schemaObject">Any type that derives from SchemaObjectBase. (E.G. DatabaseSchema, TableSchema, ColumnSchema, ViewSchema, ViewColumnSchema, IndexSchema, CommandSchema, ParameterSchema, PrimaryKeySchema, TableKeySchema)</param>
        public void SetExtendedProperties(string connectionString, SchemaObjectBase schemaObject)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets all of the tables available in the database.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="database">The database schema.</param>
        /// <returns>An array of tables for a specific database.</returns>
        public TableSchema[] GetTables(string connectionString, DatabaseSchema database)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets all columns for a given table.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="table">The table schema.</param>
        /// <returns>An array of view columns for a specific table.</returns>
        public ColumnSchema[] GetTableColumns(string connectionString, TableSchema table)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets all the views available for a given database.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="database">The database schema.</param>
        /// <returns>An array of views for a specific database.</returns>
        public ViewSchema[] GetViews(string connectionString, DatabaseSchema database)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the columns for a given view.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="view">The view schema.</param>
        /// <returns>An array of view columns for a specific view.</returns>
        public ViewColumnSchema[] GetViewColumns(string connectionString, ViewSchema view)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the definition for a given view.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="view">The view schema.</param>
        /// <returns>The definition of a view.</returns>
        public string GetViewText(string connectionString, ViewSchema view)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the primary key for a given table.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="table">The table schema.</param>
        /// <returns>An the primary key for a specific table.</returns>
        public PrimaryKeySchema GetTablePrimaryKey(string connectionString, TableSchema table)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets all of the table keys for a given table.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="table">The table schema.</param>
        /// <returns>An array of keys for a specific table.</returns>
        public TableKeySchema[] GetTableKeys(string connectionString, TableSchema table)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gats all of the indexes for a given table.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="table">The table schema.</param>
        /// <returns>An array of indexes for a specific table.</returns>
        public IndexSchema[] GetTableIndexes(string connectionString, TableSchema table)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the data from the given table.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="table">The table schema.</param>
        /// <returns>A DataTable containing the data of the specific table.</returns>
        public DataTable GetTableData(string connectionString, TableSchema table)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the data from a given view.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="view">The view schema.</param>
        /// <returns>A DataTable containing the data of the specific view.</returns>
        public DataTable GetViewData(string connectionString, ViewSchema view)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets all commands for the given database.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="database">The database schema.</param>
        /// <returns>An array of commands.</returns>
        public CommandSchema[] GetCommands(string connectionString, DatabaseSchema database)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the parameters for a given command.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="command">The command schema.</param>
        /// <returns>An array of parameters.</returns>
        public ParameterSchema[] GetCommandParameters(string connectionString, CommandSchema command)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the definition for a given command.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="command">The command schema.</param>
        /// <returns>The definition of a command.</returns>
        public string GetCommandText(string connectionString, CommandSchema command)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets schema information about the results of a given command.
        /// </summary>
        /// <param name="connectionString">The connection string used to connect to the target database.</param>
        /// <param name="command">The command schema.</param>
        /// <returns>An array of command results.</returns>
        public CommandResultSchema[] GetCommandResultSchemas(string connectionString, CommandSchema command)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region Implementation of IDbConnectionStringEditor

        public bool ShowEditor(string currentConnectionString)
        {
            throw new NotImplementedException();
        }

        public string ConnectionString { get; private set; }
        public bool EditorAvailable { get; private set; }

        #endregion
    }
}
